/*
    Copyright 2007 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdarg.h>
#include <windows.h>



#define VER         "0.1"
#define BUFFSZ      512
#define KEYPATH     "Software\\Valve"
#define KEYVALUE    "User Token 2"
#define KEYVALUEBCK "User Token 2 backup"
#define TITLE       "Valve games control password disabler "VER
#define TITLEMSG    "by Luigi Auriemma\n"               \
                    "e-mail: aluigi@autistici.org\n"    \
                    "web:    aluigi.org\n"              \
                    "\n"



int regkeyr(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, int len);
int regkeyw(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, int len);
int valve_enum(void);
int msgboxf(UINT buttons, char *fmt, ...);



int main(void) {
    if(!valve_enum()) {
        msgboxf(MB_OK, "No active control passwords found\n");
    }

    return(0);
}



int regkeyr(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, int len) {
    HKEY    key;

    buff[0] = 0;

    if(RegOpenKeyEx(hKey, lpSubKey, 0, KEY_READ, &key) != ERROR_SUCCESS) {
        return(-1);
    }
    if(RegQueryValueEx(key, lpValueName, NULL, REG_NONE, buff, (void *)&len) != ERROR_SUCCESS) {
        RegCloseKey(key);
        return(-1);
    }
    RegCloseKey(key);

    buff[len] = 0;
    return(0);
}



int regkeyw(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, int len) {
    HKEY    key;

    if(RegOpenKeyEx(hKey, lpSubKey, 0, KEY_WRITE, &key) != ERROR_SUCCESS) {
        return(-1);
    }
    if(RegSetValueEx(key, lpValueName, 0, REG_NONE, buff, len) != ERROR_SUCCESS) {
        RegCloseKey(key);
        return(-1);
    }
    RegCloseKey(key);

    return(0);
}



int valve_enum(void) {
    HKEY    key;
    int     len,
            k,
            found   = 0;
    char    regbuff[BUFFSZ],
            token[33],
            tokenbck[33],
            *p;

    if(RegOpenKeyEx(HKEY_CURRENT_USER, KEYPATH, 0, KEY_READ, &key)) return(0);
    p = regbuff + sprintf(regbuff, "%s\\", KEYPATH);

    for(k = 0; ; k++) {
        len = BUFFSZ - 11;
        if(RegEnumKeyEx(
            key,
            k,
            p,
            (void *)&len,
            NULL,
            NULL,
            NULL,
            NULL)) break;

        strcat(p, "\\Settings");

        if(regkeyr(HKEY_CURRENT_USER, regbuff, KEYVALUE,    token,    sizeof(token))
          < 0) continue;

        if(
          (regkeyr(HKEY_CURRENT_USER, regbuff, KEYVALUEBCK, tokenbck, sizeof(tokenbck)) < 0)
          || !tokenbck[0]) {

            if(!token[0]) continue;
            found++;

            if(msgboxf(MB_YESNO,
              "%s\\%s\\%s\n"
              "\n"
              "do you want to DISABLE this control password (you can re-enable it later)?\n",
              regbuff, KEYVALUE, token) == IDYES) {

                if(regkeyw(HKEY_CURRENT_USER, regbuff, KEYVALUE,    NULL,  0)
                  < 0) goto error;
                if(regkeyw(HKEY_CURRENT_USER, regbuff, KEYVALUEBCK, token, strlen(token))
                  < 0) goto error;
            }

        } else {
            found++;

            if(msgboxf(MB_YESNO,
              "%s\\%s\\%s\n"
              "\n"
              "do you want to re-ENABLE this control password?\n",
              regbuff, KEYVALUE, tokenbck) == IDYES) {

                if(regkeyw(HKEY_CURRENT_USER, regbuff, KEYVALUEBCK, NULL,     0)
                  < 0) goto error;
                if(regkeyw(HKEY_CURRENT_USER, regbuff, KEYVALUE,    tokenbck, strlen(tokenbck))
                  < 0) goto error;
            }
        }
    }

    RegCloseKey(key);
    return(found);

error:
    RegCloseKey(key);

    FormatMessage(
      FORMAT_MESSAGE_FROM_SYSTEM,
      0,
      GetLastError(),
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
      (char *)&regbuff,
      sizeof(regbuff),
      NULL);

    msgboxf(MB_OK,
        "An error occurred during the writing of the registry keys:\n"
        "%s\n", regbuff);

    exit(1);
    return(0);
}



int msgboxf(UINT buttons, char *fmt, ...) {
    va_list ap;
    int     len;
    char    buff[BUFFSZ];

    va_start(ap, fmt);
    len = sprintf(buff, "%s", TITLEMSG);
    len += vsnprintf(buff + len, sizeof(buff) - len - 1, fmt, ap);
    va_end(ap);

    if((len < 0) || (len >= sizeof(buff))) {
        strcpy(buff + sizeof(buff) - 6, "...\n");
    }

    return(MessageBox(0, buff, TITLE, MB_TASKMODAL | buttons));
}

